/*
mesmic2125.c
by TJ Johnson
3/24/09
A basic demo file that shows the use of the Mesmic2125 Driver header. 

Dont forget to include a Output folder in order for this to compile correctly.

Xout is pin 0
Yout is pin 1

Please see header file for more info.

*/


#include <stdio.h>
#include <stdarg.h>
#include <propeller.h>
#include "asio.h"
#include "Mesmic2125header.h"

const int X_IN = 0;
const int Y_IN = 1;

main()
	{
    int xVal,yVal, i;
	
	asio_init(57600); // start the terminal at 57600 baud rate
    mesmicStart(X_IN,Y_IN); // start the driver from the header file
	
	
    puts("Program Started");
	while(1)
	{
	  xVal = rawX(); // get the x value
	  yVal = rawY(); // get the y value
	  
	  putchar(0);
	  puts("Welcome to the Mesmic 2125 Demo");
	  
      printf("The x value is '%d' \n",xVal );
	  printf("The y value is '%d' \n",yVal );
	  for(i = 0; i < 100000; i++); //create a wait loop to make a pause
	}
	}
/*
{{

+------------------------------------------------------------------------------------------------------------------------------+
                                                   TERMS OF USE: MIT License                                                                                                              
+------------------------------------------------------------------------------------------------------------------------------
Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation     
files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy,    
modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software
is furnished to do so, subject to the following conditions:                                                                   
                                                                                                                              
The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.
                                                                                                                              
THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE          
WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR         
COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE,   
ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.                         
+------------------------------------------------------------------------------------------------------------------------------+
}}      

*/