	.area text(rom,rel)
	.dbfile ..\..\..\..\..\..\..\PROGRA~1\iccv7prop\Projects\MESMIC~1\v2\Mesmic2125\Mesmic2125Demo.c
	.dbfile C:\PROGRA~1\iccv7prop\Projects\MESMIC~1\v2\Mesmic2125\Mesmic2125header.h
	.dbfunc e mesmicStart _mesmicStart fV
;           pinY -> R1
;           pinX -> R0
_mesmicStart::
	@FENTER	
	.long R15,0	
	.dbline -1
	.dbline 63
; /* Parallax Mesmic 2125 Driver Header
; By TJ Johnson
; 3/24/09
; 
; Version 1
; Returns the accleration in clock counts of the pulse.
; Based on code from the BS2 compatablity libary in spin. Thanks to
;   *         Primary Author: Martin Hebel          *
;   *       Electronic Systems Technologies         *
;   *   Southern Illinois University Carbondale     *
;   *            www.siu.edu/~isat/est              *
;   *                                               *
;   *   Additional Code from:                       *
;   *     Andy Lindsay, Parallax                    *
;   *     Paul B. Voss, Smith College               *
;   *           www.science.smith.edu/cmet/    
;   
;   
; See end of file for MIT use.  
; 
; NOTES:
; The mesmic 2125 unit outputs a pulse high of the accleration in that direction
; at 100hz. For a raw accleration in units of g it will vary according to your 
; clock speed. See the parallax data sheet for more info.
; 
; You must call memicStart before calling either of the return funcitons.
; 
; Both return functions are blocking and use counter A of the cog they are called
; from.
; 
; 
; */
; // Header information
; #include <propeller.h>
; 
; 
; 
; // Global Constants
; 
; 
; 
; // Global Variables
; int pinXglobal, pinYglobal;//Global Variables to store pinx and y in.
; 
; 
; //Function Protypes
; 		   //mesmicStart( pin x, pin y) 
; 		   //Setup the driver
; 		   void mesmicStart(int pinX, int pinY);
; 		   
; 		   //Return the time x pulse in clk counts
; 		   int rawX(void);
; 		   
; 		   //Return the time of y pulse in clk counts
; 		   int rawY(void);
; 
; 
; 
; //Functions
; 
; // Set up the IO pins
; void mesmicStart(int pinX, int pinY)
; {
L2:
	.dbline 64
; CLR(DIRA, pinX); // Set pinX to input
	.dbline 64
	mov R15,#1	
	shl R15,R0	
	neg R15,R15	
	sub R15,#1	
	and 0x1f6,R15	
	.dbline 64
L3:
	.dbline 64
L5:
	.dbline 65
; CLR(DIRA, pinY); // Set pinY to input
	.dbline 65
	mov R15,#1	
	shl R15,R1	
	neg R15,R15	
	sub R15,#1	
	and 0x1f6,R15	
	.dbline 65
L6:
	.dbline 65
	.dbline 67
; 
; pinXglobal = pinX; // save the pin to the global vars.
	@FSTOREL	
	.long _pinXglobal	
	.long R0	
	.dbline 68
; pinYglobal = pinY;
	@FSTOREL	
	.long _pinYglobal	
	.long R1	
	.dbline -2
L1:
	@FPOP	
	.long R15,0	
	@FRET
	.dbline 0 ; func end
	.dbsym r pinY 1 I
	.dbsym r pinX 0 I
	.dbend
	.dbfunc e rawX _rawX fI
;       pinXMask -> R1
_rawX::
	@FENTER	
	.long R14,R15,0	
	.dbline -1
	.dbline 77
; 
; 
; 
; }
; 
; 
; 
; int rawX(void)
; {
L9:
	.dbline 86
; /*{
;   Reads duration of Pulse on pin defined for state, returns duration in 1/clkFreq increments - 12.5nS at 80MHz
;   Note: Absence of pulse can cause cog lockupe
;     
;     
; */
;   int pinXMask; // Set a variable for a pin x mask
;   
;   SET(pinXMask, pinXglobal);  // Set the pinx pin high in the mask
	.dbline 86
	@FLOADL	
	.long _pinXglobal	
	.long R15	
	mov R14,#1	
	shl R14,R15	
	or R1,R14	
	.dbline 86
L10:
	.dbline 86
	.dbline 87
;   CTRA = 0; // Clear Counter A
	mov 0x1f8,#0
	.dbline 89
;   
;   CTRA = (0b11010 << 26 ) | (0b001 << 23) | (0 << 9) | (pinXglobal); // set up counter, A level count
	@FLDCNST	
	.long 1753219072	
	mov R15,TEMP0	
	@FLOADL	
	.long _pinXglobal	
	.long R14	
	or R14,R15	
	mov 0x1f8,R14
	.dbline 90
;   FRQA = 1;
	mov 0x1fa,#1
L12:
	.dbline 91
;   WAITPNE( pinXMask, pinXMask);                       // Wait for opposite state ready
	.dbline 91
	waitpne R1, R1 WZ
	.dbline 91
L13:
	.dbline 91
	.dbline 92
;   PHSA = 0;                                           // Clear count
	mov 0x1fc,#0
L15:
	.dbline 93
;   WAITPEQ(pinXMask, pinXMask);                        // wait for pulse
	.dbline 93
	waitpeq R1, R1 WZ
	.dbline 93
L16:
	.dbline 93
L18:
	.dbline 94
;   WAITPNE(pinXMask,pinXMask);                         // Wait for pulse to end
	.dbline 94
	waitpne R1, R1 WZ
	.dbline 94
L19:
	.dbline 94
	.dbline 95
;   return PHSA; 										  // Return duration as counts
	mov R15,0x1fc
	mov R0,R15	
	.dbline -2
L8:
	@FPOP	
	.long R15,R14,0	
	@FRET
	.dbline 0 ; func end
	.dbsym r pinXMask 1 I
	.dbend
	.dbfunc e rawY _rawY fI
;       pinYMask -> R1
_rawY::
	@FENTER	
	.long R14,R15,0	
	.dbline -1
	.dbline 105
; 
;   
;   
; 
; 
; }
; 
; 
; int rawY(void)
; {
L22:
	.dbline 114
; /*{
;   Reads duration of Pulse on pin defined for state, returns duration in 1/clkFreq increments - 12.5nS at 80MHz
;   Note: Absence of pulse can cause cog lockupe
;     
;     
; */
;   int pinYMask; // Set a variable for a pin x mask
;   
;   SET(pinYMask, pinYglobal);  // Set the pinx pin high in the mask
	.dbline 114
	@FLOADL	
	.long _pinYglobal	
	.long R15	
	mov R14,#1	
	shl R14,R15	
	or R1,R14	
	.dbline 114
L23:
	.dbline 114
	.dbline 115
;   CTRA = 0; // Clear Counter A
	mov 0x1f8,#0
	.dbline 117
;   
;   CTRA = (0b11010 << 26 ) | (0b001 << 23) | (0 << 9) | (pinYglobal); // set up counter, A level count
	@FLDCNST	
	.long 1753219072	
	mov R15,TEMP0	
	@FLOADL	
	.long _pinYglobal	
	.long R14	
	or R14,R15	
	mov 0x1f8,R14
	.dbline 118
;   FRQA = 1;
	mov 0x1fa,#1
L25:
	.dbline 119
;   WAITPNE( pinYMask, pinYMask);                       // Wait for opposite state ready
	.dbline 119
	waitpne R1, R1 WZ
	.dbline 119
L26:
	.dbline 119
	.dbline 120
;   PHSA = 0;                                           // Clear count
	mov 0x1fc,#0
L28:
	.dbline 121
;   WAITPEQ(pinYMask, pinYMask);                        // wait for pulse
	.dbline 121
	waitpeq R1, R1 WZ
	.dbline 121
L29:
	.dbline 121
L31:
	.dbline 122
;   WAITPNE(pinYMask,pinYMask);                         // Wait for pulse to end
	.dbline 122
	waitpne R1, R1 WZ
	.dbline 122
L32:
	.dbline 122
	.dbline 123
;   return PHSA; 										  // Return duration as counts
	mov R15,0x1fc
	mov R0,R15	
	.dbline -2
L21:
	@FPOP	
	.long R15,R14,0	
	@FRET
	.dbline 0 ; func end
	.dbsym r pinYMask 1 I
	.dbend
	.area lit(rom,rel)
	.align	4
_X_IN::
	.long 0
	.dbfile C:\PROGRA~1\iccv7prop\Projects\MESMIC~1\v2\Mesmic2125\Mesmic2125Demo.c
	.dbsym e X_IN _X_IN I
	.align	4
_Y_IN::
	.long 1
	.dbsym e Y_IN _Y_IN I
	.area text(rom,rel)
	.dbfile C:\PROGRA~1\iccv7prop\Projects\MESMIC~1\v2\Mesmic2125\Mesmic2125Demo.c
	.dbfunc e main _main fI
;           yVal -> R4
;           xVal -> R5
;              i -> R4
_main::
	sub HRSP,#8	
	.dbline -1
	.dbline 27
; /*
; mesmic2125.c
; by TJ Johnson
; 3/24/09
; A basic demo file that shows the use of the Mesmic2125 Driver header. 
; 
; Dont forget to include a Output folder in order for this to compile correctly.
; 
; Xout is pin 0
; Yout is pin 1
; 
; Please see header file for more info.
; 
; */
; 
; 
; #include <stdio.h>
; #include <stdarg.h>
; #include <propeller.h>
; #include "asio.h"
; #include "Mesmic2125header.h"
; 
; const int X_IN = 0;
; const int Y_IN = 1;
; 
; main()
; 	{
	.dbline 30
;     int xVal,yVal, i;
; 	
; 	asio_init(57600); // start the terminal at 57600 baud rate
	@FLDCNST	
	.long 57600	
	mov R0,TEMP0	
	@FCALL	
	.long _asio_init	
	.dbline 31
;     mesmicStart(X_IN,Y_IN); // start the driver from the header file
	@FLOADL	
	.long _X_IN	
	.long R0	
	@FLOADL	
	.long _Y_IN	
	.long R1	
	@FCALL	
	.long _mesmicStart	
	.dbline 34
; 	
; 	
;     puts("Program Started");
	@FLDCNST	
	.long L35	
	mov R0,TEMP0	
	@FCALL	
	.long _puts	
	add PC,#168	;Jump to L37
L36:
	.dbline 36
; 	while(1)
; 	{
	.dbline 37
; 	  xVal = rawX(); // get the x value
	@FCALL	
	.long _rawX	
	mov R15,R0	
	mov R5,R0	
	.dbline 38
; 	  yVal = rawY(); // get the y value
	@FCALL	
	.long _rawY	
	mov R15,R0	
	mov R4,R0	
	.dbline 40
; 	  
; 	  putchar(0);
	mov R0,#0	
	@FCALL	
	.long _putchar	
	.dbline 41
; 	  puts("Welcome to the Mesmic 2125 Demo");
	@FLDCNST	
	.long L39	
	mov R0,TEMP0	
	@FCALL	
	.long _puts	
	.dbline 43
; 	  
;       printf("The x value is '%d' \n",xVal );
	@FLDCNST	
	.long L40	
	mov R15,TEMP0	
	mov TEMP5,HRSP	
	wrlong R15,HRSP	
	mov TEMP5,HRSP	
	add TEMP5,#4	
	wrlong R5,TEMP5	
	@FCALL	
	.long _printf	
	.dbline 44
; 	  printf("The y value is '%d' \n",yVal );
	@FLDCNST	
	.long L41	
	mov R15,TEMP0	
	mov TEMP5,HRSP	
	wrlong R15,HRSP	
	mov TEMP5,HRSP	
	add TEMP5,#4	
	wrlong R4,TEMP5	
	@FCALL	
	.long _printf	
	.dbline 45
; 	  for(i = 0; i < 100000; i++); //create a wait loop to make a pause
	mov R4,#0	
L42:
	.dbline 45
L43:
	.dbline 45
	add R4,#1	
	.dbline 45
	@FLDCNST	
	.long 100000	
	cmps R4,TEMP0	WC
IF_B	sub PC,#20	;Jump to L42
	.dbline 46
; 	}
L37:
	.dbline 35
	sub PC,#172	;Jump to L36
X0:
	.dbline -2
L34:
	add HRSP,#8	
	@FRET
	.dbline 0 ; func end
	.dbsym r yVal 4 I
	.dbsym r xVal 5 I
	.dbsym r i 4 I
	.dbend
	.area bss(ram,rel)
	.dbfile C:\PROGRA~1\iccv7prop\Projects\MESMIC~1\v2\Mesmic2125\Mesmic2125Demo.c
	.align	4
_pinYglobal::
	.blkb 4
	.dbfile C:\PROGRA~1\iccv7prop\Projects\MESMIC~1\v2\Mesmic2125\Mesmic2125header.h
	.dbsym e pinYglobal _pinYglobal I
	.align	4
_pinXglobal::
	.blkb 4
	.dbsym e pinXglobal _pinXglobal I
	.area lit(rom,rel)
L41:
	.byte 'T,'h,'e,32,'y,32,'v,'a,'l,'u,'e,32,'i,'s,32,39
	.byte 37,'d,39,32,10,0
L40:
	.byte 'T,'h,'e,32,'x,32,'v,'a,'l,'u,'e,32,'i,'s,32,39
	.byte 37,'d,39,32,10,0
L39:
	.byte 'W,'e,'l,'c,'o,'m,'e,32,'t,'o,32,'t,'h,'e,32,'M
	.byte 'e,'s,'m,'i,'c,32,50,49,50,53,32,'D,'e,'m,'o,0
L35:
	.byte 'P,'r,'o,'g,'r,'a,'m,32,'S,'t,'a,'r,'t,'e,'d,0
