#include "LPC214x.H"  	// LPC2148 MPU Register
#include "timer.h"
unsigned char flag_timer0_interrupt;   //extern variable to indicate  when the interrupr occur

/****************************************************/
/* Target MCU  : NXP ARM7-LPC2148  -UAV             */
/*       	   : X-TAL : 12.00 MHz                  */
/*             : Run Speed 60.00 MHz (With PLL)     */
/*             : PLL Setup = M(5),P(2)				*/
/*             : VPB Clock = CPU Clock = 60.00 MHz	*/
/* Keil Editor : uVision3 V3.03a                    */
/* Compiler    : Keil CARM V2.50a		            */
/* Function    : inital timer 0 with match interrupt*/
/****************************************************/
void init_timer0(void)
{
T0TCR=3;//TC and PR don't count enable
T0PR=Presacle;//tan so dem cua TC = PCLK/(PR+1)


#if(ENABLE_TIMER0_MATCH_INTERRUPT)
	T0MCR=3;//interrupt match0 enable and TC reset when match 
	T0MR0=Match_value;//TC reaches to T0MR0 and occur match0 interrupt
	//interrupt
	VICVectCntl0=0x24;//choose Source Int Timer0=4, and enable IRQ slot
	VICVectAddr0=(unsigned)	Timer0_interrupt_Handler;
	VICIntEnable|=1<<4;//enable Timer0 interrupt source
#endif

T0TCR=0x01;// TC begin counting
}


void init_timer0_with_parameter(unsigned int prescale,unsigned int matchvalue)
{
T0TCR=3;//TC and PR don't count enable
T0PR=prescale;//tan so dem cua TC = PCLK/(PR+1)


	T0MCR=3;//interrupt match0 enable and TC reset when match 
	T0MR0=matchvalue;//TC reaches to T0MR0 and occur match0 interrupt
	//interrupt
	VICVectCntl0=0x24;//choose Source Int Timer0=4, and enable IRQ slot
	VICVectAddr0=(unsigned)	Timer0_interrupt_Handler;
	VICIntEnable|=1<<4;//enable Timer0 interrupt source

T0TCR=0x01;// TC begin counting
}
/****************************************************/
/* Function :  match0  interrupt handler			*/
/****************************************************/
void Timer0_interrupt_Handler(void)__irq
{	 	
	T0IR=1;			   //xoa co ngat de cho match0 tiep theo xay ra
	flag_timer0_interrupt=1;
	VICVectAddr = 0x00000000;	// Reset Global Interrupt and return
}

/****************************************************/
/* Function :  get timer tick            			*/
/****************************************************/
unsigned int get_system_tick0(void)
{
return (T0TC);
}

/****************************************************/
/* Function :  set timer_tick0 to timer0 counter	*/
/****************************************************/
void set_system_tick0(unsigned int time_tick0)
{
T0TC=time_tick0;
}

