//============================================================================
//  I2C.c                      Allen Marincak               Ver 1.0   Mar 2009
//
//  Modified and Ported from the I2C Spin Object by James Burrows
//============================================================================

#ifndef __ajm_i2c__
#define __ajm_i2c__

void            I2C_Init            ( unsigned char pinDat, unsigned char pinClk );
unsigned char   I2C_IsDevPresent    ( unsigned char devAddr );
unsigned char   I2C_ReadDev         ( unsigned char devAddr );
unsigned char   I2C_ReadDevReg      ( unsigned char devAddr, unsigned char reg);
unsigned char   I2C_ReadDevCmd      ( unsigned char devAddr, unsigned char reg, unsigned char cmd );
unsigned char   I2C_WriteDev        ( unsigned char devAddr, unsigned char i2cData);
unsigned char   I2C_WriteDev2       ( unsigned char devAddr, unsigned char i2cData1, unsigned char i2cData2 );
unsigned char   I2C_WriteDev3       ( unsigned char devAddr, unsigned char i2cData1, unsigned char i2cData2, unsigned char i2cData3 );
unsigned char   I2C_WriteDev4       ( unsigned char devAddr, unsigned char i2cData1, unsigned char i2cData2, unsigned char i2cData3, unsigned char i2cData4 );
unsigned char   I2C_WriteDevBuf     ( unsigned char devAddr, unsigned char *bufAddr );
unsigned char   I2C_WriteDevRegBuf  ( unsigned char devAddr, unsigned char reg, unsigned char *bufAddr );
unsigned char   I2C_WriteDevStr     ( unsigned char devAddr, unsigned char *bufAddr );
unsigned char   I2C_WriteDevRegStr  ( unsigned char devAddr, unsigned char reg, unsigned char *bufAddr );

#define I2C_WriteDevReg( a, r, c )  I2C_WriteDev2( a, r, c )
#define I2C_WriteDevReg2( a, r, c, d1 ) I2C_WriteDev3( a, r, c, d1 )
#define I2C_WriteDevReg3( a, r, c, d1, d2 ) I2C_WriteDev4( a, r, c, d1, d2 )

#endif  // __ajm_i2c__

//============================================================================
//                        TERMS OF USE: MIT License                                                       
//============================================================================
// Permission is hereby granted, free of charge, to any person obtaining a 
// copy of this software and associated documentation files (the "Software"),
// to deal in the Software without restriction, including without limitation
// the rights to use, copy, modify, merge, publish, distribute, sublicense, 
// and/or sell copies of the Software, and to permit persons to whom the 
// Software is furnished to do so, subject to the following conditions:
//                                       
// The above copyright notice and this permission notice shall be included in
// all copies or substantial portions of the Software.
//
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
// IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
// FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
// AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
// LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
// FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER 
// DEALINGS IN THE SOFTWARE.
//============================================================================
         